/*
	Slimp : Slimp Light and Intelligent Media Player.
	Copyright (C) 2009 Guillaume Royer <groyer.perso@gmail.com>

	This file is a part of Slimp.
	
	Slimp is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Slimp is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slimp; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	*/

#include<gtk/gtk.h>
#include<gst/gst.h>
#include<glib.h>
#include<glib/gi18n.h>
#include"slimp.h"
#include"slimp_include.h"

int slimp_leave(GtkWidget* widget, GdkEvent* event, gpointer data){
	Slimp* slimp;
	slimp = (Slimp*) data;
	if(slimp->playing_state != SLIMP_STATE_NULL) g_main_loop_quit(slimp->playing->loop);
	gtk_main_quit();
}

int slimp_open(gchar *filename, Slimp* slimp){
	if(!(slimp->playing_state == SLIMP_STATE_NULL)){
		slimp_close_stream(slimp);
	}
	gchar* uri;
        if (strstr(filename, ":")) {
		uri = filename ;
	}
	else {
		uri = g_filename_to_uri(filename, NULL, NULL);
	}
	slimp->toplay->uri = uri;
	slimp->playing_state = SLIMP_STATE_NULL;
	return TRUE;
}

int main (int argc, char *argv[])
{
	GtkWidget *main_box;
	Slimp self;
	SlimpPlaying playing;
	SlimpSong toplay;
	self.toplay = &toplay;
	self.playing_state = SLIMP_STATE_NULL;
	self.playing = &playing;
	if(argc == 2) slimp_open((gchar*) argv[1], &self);
	else self.toplay->uri = NULL;
	/*GStreamer init*/
	gst_init(&argc, &argv);
	/*GTK init*/
	gtk_init(&argc, &argv);
	
	self.main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL); //New window
	gtk_window_set_title(GTK_WINDOW(self.main_window), "Slimp");
	gtk_window_set_default_size(GTK_WINDOW(self.main_window), 400, 0);
	g_signal_connect(G_OBJECT(self.main_window), "delete-event", G_CALLBACK(slimp_leave), &self);
	self.player = create_player(&self); //Create player
	self.menu = create_menu(&self); //Create menu
	main_box = gtk_vbox_new(FALSE, 0); //Create main box
	gtk_box_pack_end(GTK_BOX(main_box), GTK_WIDGET(self.player->status_bar), FALSE, FALSE, 0);
	gtk_box_pack_end(GTK_BOX(main_box), GTK_WIDGET(self.player->box), FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(main_box), GTK_WIDGET(self.menu->box), FALSE, FALSE, 0);
	gtk_container_add(GTK_CONTAINER(self.main_window), main_box);
	
	gtk_widget_show_all(self.main_window);
	gtk_main();
	
	return EXIT_SUCCESS;
}
