/*
	Slimp : Slimp Light and Intelligent Media Player.
	Copyright (C) 2009 Guillaume Royer <groyer.perso@gmail.com>

	This file is a part of Slimp.
	
	Slimp is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 3 of the License, or
	(at your option) any later version.

	Slimp is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Slimp; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	*/

#ifndef INCLUDE_SLIMP
#define INCLUDE_SLIMP

#define SLIMP_TIME_ARGS(t) (t-(t%60))/60, t%60
#define SLIMP_FORMAT_TIME G_GUINT64_FORMAT ":%02" G_GUINT64_FORMAT
#define SLIMP_STR_POS_OVER_DUR(p,d) g_strdup_printf("%" SLIMP_FORMAT_TIME " / %" SLIMP_FORMAT_TIME, SLIMP_TIME_ARGS(GST_TIME_AS_SECONDS(p)), SLIMP_TIME_ARGS(GST_TIME_AS_SECONDS(d)))

int slimp_leave(GtkWidget* widget, GdkEvent* event, gpointer data);

typedef struct SlimpMenu SlimpMenu;
struct SlimpMenu{
	GtkWidget* box;
};

typedef struct SlimpPlaying SlimpPlaying;
struct SlimpPlaying
{
	GstElement* pipeline;
	GstBus* bus;
	gchar* uri;
	GMainLoop *loop;
	gint64 position;
	gint64 duration;
};

typedef struct SlimpPlayer SlimpPlayer;
struct SlimpPlayer{
	GtkWidget* box;
	GtkWidget* scale;
	gboolean scale_lock;
	GtkObject* adjustment;
	GtkWidget* button;
	GtkWidget* button_label;
	GtkScaleButton* volume_button;
	GtkWidget* time_label;
	GtkWidget* status_bar;
	guint status_bar_id;
};

typedef struct SlimpSong SlimpSong;
struct SlimpSong{
	gchar* uri;
};

typedef enum SlimpPlayingState SlimpPlayingState;
enum SlimpPlayingState{
	SLIMP_STATE_NULL,
	SLIMP_STATE_PLAYING,
	SLIMP_STATE_PAUSED,
	SLIMP_STATE_PROCESSING	
};

typedef struct Slimp Slimp;
struct Slimp{
	GtkWidget* main_window;
	SlimpPlayingState playing_state;
	SlimpPlayer* player;
	SlimpPlaying* playing;
	SlimpSong* toplay;
	SlimpMenu* menu;
};
#endif
